package com.gnarly.engine.utils;

import org.joml.Vector3f;

public class CHitbox {

	private Vector3f center;
	private float radius;
	
	public CHitbox(float x, float y, float radius) {
		center = new Vector3f(x, y, 0);
		this.radius = radius;
	}
	
	public Vector3f collisionAdjust(CHitbox hitbox) {
		Vector3f distance = hitbox.center.sub(center, new Vector3f());
		distance.x = (float)Math.abs(distance.x);
		distance.y = (float)Math.abs(distance.y);

		if (2 * radius * radius < distance.lengthSquared()) {
			float angle = (float) Math.asin((center.x - hitbox.center.x)/(center.y - hitbox.center.y));
			distance.x = (float) Math.cos(angle) * 2 * radius * radius;
			distance.y = (float) Math.sin(angle) * 2 * radius * radius;
		}
		return distance;
	}
	
	public boolean checkCollision(CHitbox hitbox) {
		Vector3f distance = hitbox.center.sub(center, new Vector3f());
		distance.x = (float)Math.abs(distance.x);
		distance.y = (float)Math.abs(distance.y);
		return 2 * radius * radius < distance.lengthSquared();
	}
	
	public void setPosition(float x, float y) {
		center.x = x;
		center.y = y;
	}
	
	public float getX() {
		return center.x;
	}

	public float getY() {
		return center.y;
	}
	
	public Vector3f getCenter() {
		return center;
	}
	
	public float radius() {
		return radius;
	}
}
