package com.gnarly.game.panels;

import com.gnarly.engine.display.Camera;
import com.gnarly.engine.display.Window;
import com.gnarly.game.objects.Character;
import com.gnarly.game.objects.Stage;

public class PlayPanel {
	
	private Stage stage;
	private Camera camera;
	private Character character;
	
	public PlayPanel(Window window, Camera camera) {
		this.camera = camera;
		stage = new Stage(camera, "mountain");
		character = new Character(window, camera, "blue stick", stage.getCenter().x, stage.getFloor());
		camera.setCenterPosition(stage.getCenter());
	}
	
	public void update() {
		stage.update();
		character.update();
		boolean hit = stage.checkPlayer(character.getRHitbox());
		character.hitStage(hit);
	}
	
	public void render() {
		stage.render();
		character.render();
	}
}
